function [x, it, nrm] = conjgrad(x0,A,b, itmax,epsi)

x = x0;
r = b - matvec(A,x) ;
p = r ;

rr = mydot(r,r) ;
it = 0 ;
nrm = sqrt(rr) ;
if( nrm  < epsi) , return, end



for it =1:itmax
    Ap = matvec(A,p) ;
    
    alpha = rr/mydot(Ap,p) ;
    x = x + alpha * p ;
    r = r - alpha  * Ap ;
    
    rrn = mydot(r,r) ;
    beta = rrn/rr ;
    
    p = r  + beta*p ;  
    
    nrm = sqrt(rrn) ;
    if( nrm  < epsi) , return, end
    rr = rrn ;
end
